=== debian/changelog ===
gringo (5.2.2-5) unstable; urgency=medium

  * fix FTBFS with gringo-python3-utf8.patch
  * debian/rules: report ctest logs in case of error

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 05 Feb 2018 07:39:21 +0100

gringo (5.2.2-4) unstable; urgency=medium

  * setup build environment for python3
    + debian/control: setup Build-Depends for python3
    + debian/rules: force PYTHON_EXECUTABLE to /usr/bin/python3
  * FTBFS: dh_auto_test needs LD_LIBRARY_PATH for libclingo

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 04 Feb 2018 21:35:05 +0100

gringo (5.2.2-3) unstable; urgency=medium

  * add dep8 testsuite
    + debian/rules: build, run, and output upstream tests
    + debian/tests: add dep8 tests
  * debian/symbols: add ia64, update templinst archs

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 04 Feb 2018 09:22:41 +0100

gringo (5.2.2-2) unstable; urgency=medium

  * update debian/control and debian/compat
    + update Vcs-Git and Vcs-Browser for salsa
    + bump Standards-Version to 4.1.3
    + bump debhelper compatibility version to 11
  * debian/symbols: update amd64 symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 03 Feb 2018 15:17:29 +0100

gringo (5.2.2-1) unstable; urgency=medium

  * New upstream version 5.2.2
  * drop upstream applied gringo-remove-wrong-assertion.patch
  * debian/symbols: add arm64 kfreebsd-amd64 kfreebsd-i386 symbols
    pkgkde-symbolshelper batchpatch -v 1

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 10 Nov 2017 08:08:58 +0100

gringo (5.2.1-4) unstable; urgency=medium

  * debian/symbols: fix FTBFS on armel

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 04 Nov 2017 14:55:24 +0100

gringo (5.2.1-3) unstable; urgency=medium

  * add patch from upstream commit 02c6d85 to fix wrong assertion
  * debian/control: Build-Depends to cmake >= 3.1.0

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 04 Nov 2017 11:14:23 +0100
