=== debian/watch ===
# watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/gringo-$1\.tar\.gz/ \
  https://github.com/potassco/gringo/tags .*/v?(\d\S+)\.tar\.gz
