## gringo 5.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,8 +8,8 @@
     cmake_policy(SET CMP0063 NEW)
 endif()
 if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
-	message(STATUS "No build type selected - using 'Release'")
-	set(CMAKE_BUILD_TYPE "Release")
+    message(STATUS "No build type selected - using 'Release'")
+    set(CMAKE_BUILD_TYPE "Release")
 endif()
 
 include(GNUInstallDirs)
@@ -40,15 +40,18 @@
 CMAKE_DEPENDENT_OPTION(CLINGO_BUILD_LUA_SHARED "build luaclingo library shared"   OFF "NOT CLINGO_BUILD_STATIC"  OFF)
 
 option(PYCLINGO_USER_INSTALL "install the python module in the user's site directory" ON)
+option(PYCLINGO_DYNAMIC_LOOKUP "do not link to python library and pass linker option `-undefined link_dynamic`" ${APPLE})
 CMAKE_DEPENDENT_OPTION(PYCLINGO_USE_INSTALL_PREFIX "install the python module under the install prefix" OFF "NOT PYCLINGO_USER_INSTALL" OFF)
 
 set(CLINGO_CLINGOPATH "" CACHE STRING "global search directories for clingo's include statement")
+set(CLINGO_USE_LIB OFF CACHE BOOL "advanced option to build python and lua modules against an existing libclingo")
 
 mark_as_advanced(CLINGO_BUILD_WEB)
 mark_as_advanced(CLINGO_BUILD_STATIC)
 mark_as_advanced(CLINGO_BUILD_SHARED)
 mark_as_advanced(CLINGO_BUILD_PY_SHARED)
 mark_as_advanced(CLINGO_BUILD_LUA_SHARED)
+mark_as_advanced(CLINGO_USE_LIB)
 
 # workaround to set custom ar and ranlib
 if (CLINGO_CMAKE_AR)
@@ -65,11 +68,10 @@
 if (CLINGO_MANAGE_RPATH)
     set(CMAKE_SKIP_BUILD_RPATH FALSE)
     set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
-    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
     set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
+    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_FULL_LIBDIR}" isSystemDir)
     if ("${isSystemDir}" STREQUAL "-1")
-        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}")
     endif()
 endif()
 
@@ -99,6 +101,7 @@
 #       that searching for the python libraries finds the matching libraries for the default python interpreter
 #       python is also used to run the tests
 find_package(PythonInterp)
+add_library(Pyclingo::Pyclingo INTERFACE IMPORTED)
 if (CLINGO_BUILD_WITH_PYTHON)
     if (CLINGO_REQUIRE_PYTHON)
         find_package(PythonLibs REQUIRED)
@@ -107,8 +110,12 @@
     endif()
     if(PYTHONLIBS_FOUND)
         add_library(Python::Python INTERFACE IMPORTED)
-        set_property(TARGET Python::Python PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
         set_property(TARGET Python::Python PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${PYTHON_INCLUDE_DIRS}")
+        if (PYCLINGO_DYNAMIC_LOOKUP)
+            set_property(TARGET Pyclingo::Pyclingo PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
+        else()
+            set_property(TARGET Python::Python PROPERTY INTERFACE_LINK_LIBRARIES "${PYTHON_LIBRARIES}")
+        endif()
     endif()
 endif()
 if (CLINGO_BUILD_WITH_LUA)
@@ -134,12 +141,19 @@
 enable_testing()
 
 # NOTE: assumes that submodule has been initialized
-set(clingo_library_targets libclingo libgringo libpotassco libclasp libreify)
 set(CLASP_BUILD_APP ${CLINGO_BUILD_APPS} CACHE BOOL "")
-add_subdirectory(clasp)
-add_subdirectory(libreify)
-add_subdirectory(libgringo)
-add_subdirectory(libclingo)
+if (CLINGO_USE_LIB)
+    set(clingo_library_targets)
+    add_library(libclingo INTERFACE IMPORTED)
+    set_property(TARGET libclingo PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${CLINGO_SOURCE_DIR}/libclingo")
+    set_property(TARGET libclingo PROPERTY INTERFACE_LINK_LIBRARIES "clingo")
+else()
+    set(clingo_library_targets libclingo libgringo libpotassco libclasp libreify)
+    add_subdirectory(clasp)
+    add_subdirectory(libreify)
+    add_subdirectory(libgringo)
+    add_subdirectory(libclingo)
+endif()
 if (PYTHONLIBS_FOUND)
     add_subdirectory(libpyclingo)
     list(APPEND clingo_library_targets libpyclingo)
@@ -152,7 +166,7 @@
 else()
     add_library(libluaclingo INTERFACE IMPORTED)
 endif()
-if (CLINGO_BUILD_APPS)
+if (CLINGO_BUILD_APPS AND NOT CLINGO_USE_LIB)
     add_subdirectory(app/reify)
     add_subdirectory(app/gringo)
     add_subdirectory(app/clingo)
