=== debian/changelog ===
gringo (5.2.3-2ubuntu1) disco; urgency=medium

  * Rename async keyword argument to _async.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 02 Nov 2018 07:42:54 +0100

gringo (5.2.3-2build1) disco; urgency=medium

  * No-change rebuild to build for python3.7 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 31 Oct 2018 12:34:47 +0000

gringo (5.2.3-2) unstable; urgency=medium

  * debian/symbols: batchpatch symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 03 Jul 2018 06:23:44 +0200

gringo (5.2.3-1) unstable; urgency=medium

  * New upstream version 5.2.3
  * debian/watch: force three-digit version
  * debian/control: bump Standards-Version to 4.1.4
  * debian/TODO.Debian: refresh TODO list
  * gringo-makefile.patch: drop Makefile
  * debian/symbols: update amd64 symbols

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 30 Jun 2018 13:27:28 +0200

gringo (5.2.2-6) unstable; urgency=medium

  * Team upload
  * Added build-dependency python3-distutils in order to fix FTBFS. Thanks
    to Adrian Bunk for the patch (closes: #896791)
  * Added debian/gbp.conf with pristine-tar=True

 -- Ralf Treinen <treinen@debian.org>  Thu, 03 May 2018 08:30:23 +0200
