=== debian/control ===
--- 
+++ 
@@ -12,8 +12,9 @@
  bison,
  liblua5.3-dev,
  python3,
- libpython3-dev
-Standards-Version: 4.1.3
+ libpython3-dev,
+ python3-distutils
+Standards-Version: 4.1.4
 Vcs-Git: https://salsa.debian.org/science-team/gringo.git
 Vcs-Browser: https://salsa.debian.org/science-team/gringo
 Homepage: https://www.potassco.org/clingo/
